import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  DeleteHumanLoopCommandInput,
  DeleteHumanLoopCommandOutput,
} from "./commands/DeleteHumanLoopCommand";
import {
  DescribeHumanLoopCommandInput,
  DescribeHumanLoopCommandOutput,
} from "./commands/DescribeHumanLoopCommand";
import {
  ListHumanLoopsCommandInput,
  ListHumanLoopsCommandOutput,
} from "./commands/ListHumanLoopsCommand";
import {
  StartHumanLoopCommandInput,
  StartHumanLoopCommandOutput,
} from "./commands/StartHumanLoopCommand";
import {
  StopHumanLoopCommandInput,
  StopHumanLoopCommandOutput,
} from "./commands/StopHumanLoopCommand";
import { SageMakerA2IRuntimeClient } from "./SageMakerA2IRuntimeClient";
export interface SageMakerA2IRuntime {
  deleteHumanLoop(
    args: DeleteHumanLoopCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteHumanLoopCommandOutput>;
  deleteHumanLoop(
    args: DeleteHumanLoopCommandInput,
    cb: (err: any, data?: DeleteHumanLoopCommandOutput) => void
  ): void;
  deleteHumanLoop(
    args: DeleteHumanLoopCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteHumanLoopCommandOutput) => void
  ): void;
  describeHumanLoop(
    args: DescribeHumanLoopCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeHumanLoopCommandOutput>;
  describeHumanLoop(
    args: DescribeHumanLoopCommandInput,
    cb: (err: any, data?: DescribeHumanLoopCommandOutput) => void
  ): void;
  describeHumanLoop(
    args: DescribeHumanLoopCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeHumanLoopCommandOutput) => void
  ): void;
  listHumanLoops(
    args: ListHumanLoopsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListHumanLoopsCommandOutput>;
  listHumanLoops(
    args: ListHumanLoopsCommandInput,
    cb: (err: any, data?: ListHumanLoopsCommandOutput) => void
  ): void;
  listHumanLoops(
    args: ListHumanLoopsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListHumanLoopsCommandOutput) => void
  ): void;
  startHumanLoop(
    args: StartHumanLoopCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartHumanLoopCommandOutput>;
  startHumanLoop(
    args: StartHumanLoopCommandInput,
    cb: (err: any, data?: StartHumanLoopCommandOutput) => void
  ): void;
  startHumanLoop(
    args: StartHumanLoopCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartHumanLoopCommandOutput) => void
  ): void;
  stopHumanLoop(
    args: StopHumanLoopCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StopHumanLoopCommandOutput>;
  stopHumanLoop(
    args: StopHumanLoopCommandInput,
    cb: (err: any, data?: StopHumanLoopCommandOutput) => void
  ): void;
  stopHumanLoop(
    args: StopHumanLoopCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StopHumanLoopCommandOutput) => void
  ): void;
}
export declare class SageMakerA2IRuntime
  extends SageMakerA2IRuntimeClient
  implements SageMakerA2IRuntime {}
